//
// Class to represent filter in OpenAL 1.1
//

#include	<stdio.h>
#include	"OpenAlFilter.h"
#include	"OpenAlExts.h"

OpenAlFilter :: OpenAlFilter  ( ALuint theType )
{
	alGenFilters ( 1, &id );
	
printf ( "id = %d\n", id );

	ok = alGetError () == AL_NO_ERROR;
	
	if ( !ok )
		return;
		
	alFilteri ( id, AL_FILTER_TYPE, type = theType );
printf ( "type %d\n", type );

	ok = alGetError () == AL_NO_ERROR;
}

OpenAlFilter :: ~OpenAlFilter ()
{
	alDeleteFilters ( 1, &id );
}

OpenAlLowPassFilter :: OpenAlLowPassFilter ( float theGain, float theHfGain ) : OpenAlFilter ( AL_FILTER_LOWPASS )
{
	gain   = theGain;
	gainHf = theHfGain;
	
	alFilterf ( id, AL_LOWPASS_GAIN,   gain   );
	alFilterf ( id, AL_LOWPASS_GAINHF, gainHf );
}

OpenAlHighPassFilter :: OpenAlHighPassFilter ( float theGain, float theLfGain ) : OpenAlFilter ( AL_FILTER_HIGHPASS )
{
	gain   = theGain;
	gainLf = theLfGain;
	
	alFilterf ( id, AL_HIGHPASS_GAIN,   gain   );
	alFilterf ( id, AL_HIGHPASS_GAINLF, gainLf );
}

OpenAlBandPassFilter :: OpenAlBandPassFilter ( float theGain, float theLfGain, float theHfGain ) : OpenAlFilter ( AL_FILTER_BANDPASS )
{
	gain   = theGain;
	gainLf = theLfGain;
	gainHf = theHfGain;
	
	alFilterf ( id, AL_BANDPASS_GAIN,   gain   );
	alFilterf ( id, AL_BANDPASS_GAINLF, gainLf );
	alFilterf ( id, AL_BANDPASS_GAINHF, gainHf );
}
