//
// Example of using OpenAL wrapper classes
//
// Author: Alex V. Boreskoff <steps3d@narod.ru>, <alexboreskoff@mtu-net.ru>
//

#include	<stdio.h>
#include	<stdlib.h>

#ifndef	_WIN32
    #include	"kbhit.h"
#else
    #include	<windows.h>
    #include	<conio.h>
    #include	<process.h>
    
    #define	initKeyboard()
    #define	closeKeyboard()
#endif

#include	"OpenAlContext.h"
#include	"OpenAlFilter.h"
#include	"OpenAlEffect.h"
#include	"OpenAlSlot.h"
#include	"SoundSource.h"
#include	"SoundData.h"

int main ()
{
	OpenAlContext	context;
	SoundData     * data = OpenAlContext :: open ( "wavdata/footsteps.wav" );
	
	if ( data == NULL )
		return 1;
		
	initKeyboard ();
	
	bool		   attached = true;
	SoundSource  * sound    = new SoundSource ( data, true );
	OpenAlFilter * filter   = new OpenAlLowPassFilter ( 1.0, 0.1 );

	if ( !filter -> isOk () )
		printf ( "Filter failure\n" );
		
	if ( !sound -> attachFilter ( filter ) )
		printf ( "Error attaching filter\n" );
	
	printf ( "Filter: %s\n", attached ? "on" : "off" );
	
	sound -> play ();

	for ( ; ; )
	{
		sound -> update ();
	
		if ( kbhit () )
		{
			int	ch = getche ();
			
			if ( ch == 27 )
				break;
				
			attached = !attached;
			
			if ( attached )
				sound -> attachFilter ( filter );
			else
				sound -> detachFilter ();
				
			printf ( "Filter: %s\n", attached ? "on" : "off" );
		}
											// make some delay
		int	i, j;
		
		for ( i = j = 0; i < 1000; i++ )
		    j += i*j + 1;	    
	}
	
	closeKeyboard ();
	
	return 0;
}
